/* Copyright (C) 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <dl-vdso.h>
#include <bits/libc-vdso.h>

static inline void
_libc_vdso_platform_setup (void)
{
  PREPARE_VERSION (linux26, "LINUX_2.6", 61765110);

  __vdso_read_tp = _dl_vdso_vsym ("__kernel_read_tp", &linux26);
  __vdso_atomic_cmpxchg_32 = _dl_vdso_vsym ("__kernel_atomic_cmpxchg_32",
					    &linux26);
  __vdso_atomic_barrier = _dl_vdso_vsym ("__kernel_atomic_barrier", &linux26);
}

#define VDSO_SETUP _libc_vdso_platform_setup

#include <sysdeps/unix/sysv/linux/init-first.c>
