/* Copyright (C) 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   In addition to the permissions in the GNU Lesser General Public
   License, the Free Software Foundation gives you unlimited
   permission to link the compiled version of this file with other
   programs, and to distribute those programs without any restriction
   coming from the use of this file. (The GNU Lesser General Public
   License restrictions do apply in other respects; for example, they
   cover modification of the file, and distribution when not linked
   into another program.)

   Note that people who make modified versions of this file are not
   obligated to grant this special exception for their modified
   versions; it is their choice whether to do so. The GNU Lesser
   General Public License gives permission to release a modified
   version without this exception; this exception also makes it
   possible to release a modified version which carries forward this
   exception.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <sysdep.h>

#ifdef HAVE_TLS_SUPPORT

#include <sysdep.h>

/* FIXME: Assign a syscall number to write_tp till kernel gets
   updated.  */
# ifndef __NR_write_tp
#  define __NR_write_tp 350
# endif

	.hidden __m68k_write_tp
ENTRY (__m68k_write_tp)
	move.l #SYS_ify (write_tp), %d0	/* System call number in %d0.  */

	lea 4(%sp), %a0			/* Address of args is 1st arg.  */
	move.l %a0, %d1

	/* Do the system call trap.  */
	trap #0

	/* Kludge: negative numbers are among the legal return values.
	   If %d0 is between -4096 and 0 then there was an error.  */
	cmp.l #-4096, %d0
	jhi SYSCALL_ERROR_LABEL

	rts
PSEUDO_END (__m68k_write_tp)

#endif
