/* Copyright (C) 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <tcb-offsets.h>

#define SAVE_PID \
	bsrl __m68k_read_tp@PLTPC  ; /* Get the thread pointer.  */ \
	movel %a0, %a1		   ; /* Save TP for RESTORE_PID.  */ \
	movel PID_OFFSET(%a1), %d1 ; /* Load the PID.  */ \
	negl %d1		   ; /* Negate the PID.  */ \
	bne 1f			   ; /* If it was zero... */ \
	movel #0x80000000, %d1	   ; /* use 0x80000000 instead.  */ \
1:	movel %d1, PID_OFFSET(%a1) ; /* Store the temporary PID.  */

#define RESTORE_PID \
	tstl %d0		; \
	beq 1f 			; /* If we are the parent... */ \
	movel PID_OFFSET(%a1), %d1 ; /* Load the saved PID.  */ \
	negl %d1		   ; /* Re-negate it.  */ \
	cmpl #0x80000000, %d1	   ; \
	bne 2f			   ; /* If it is 0x80000000... */ \
	movel #0, %d1		   ; /* Use 0 instead.  */ \
2:	movel %d1, PID_OFFSET(%a1) ; /* Restore the PID.  */ \
1:	

#include <sysdeps/unix/sysv/linux/m68k/vfork.S>
